;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================

ORG 5014

@DFile=400C
@X1Y1=4036

	JR Plot
	JR Unplot
	JR Up
;================================
; Test for XY coordinates in range
;================================
@TestXY
	LD BC,(X1Y1)		;BC=XY coordS
@TestX
	LD A,3F			;X>63?
	SUB C 
	JR NC +2
	RST 08			;Error Code:'H'
	10			;X>63
	LD A,2F			;Y>47?
	SUB B 
	RET NC
	RST 08			;Error Code:'V'
	1E			;Y>43
;================================
; Plot/Unplot routiones
;================================
@Plot
	CALL TestXY
	LD A,40
	JR +4
@Unplot
	CALL TestXY
	XOR A
	PUSH AF			;SAVE Plot/Unplot value.
	LD A,87			;A=87=NW Pixel
	BIT 0,B			;Y
	JR NZ +2		;Jump if odd line number?
	ADD A,10		;A=97=SW Pixel 
	BIT 0,C			;X
	JR Z +2			;Jump if even col number?
	ADD A,08		;A=8F=NE Pixel or A=9F=SE Pixel
	LD D,A			;D=Pixel quadrant value
	POP AF
	ADD A,D			;A=D IF UNPlot or D+64 IF Plot
	LD (PlotPX+1),A		;Self modifying code
	SRL B			;Convert Y-coord to Print coord, Y/2
	SRL C			;Convert X-coord to Print coord, X/2
	LD HL,(DFile)
	INC HL
	LD D,00
	LD E,C			;DE=Column number
	ADD HL,DE		;HL=Column position in DFile
	LD A,17			;23-Y/2
	SUB B
	LD B,A			;B=Row number
	JR Z +6
	LD DE,21
	ADD HL,DE
	DJNZ -3
	LD A,(HL)
	CP 08			;LO Pixel Chr
	JR C +1
	CPL			;HI Pixel Chr
@PlotPX
	SET 00,A		;00=SR SET/RES X,A
	BIT 3,A
	JR Z +5
	CPL
	AND 8F
	JR +2
	AND 0F			;Low value PIXEL, codes 1 to 7
	LD (HL),A		;Hi value PIXEL, codes 128 to 135
	RET 
;================================
; Scroll Up
;================================
@Up
	LD HL,(DFile)
	LD D,H 
	LD E,L 
	LD BC,0021 
	ADD HL,BC 
	LD BC,02F7 
	LDIR 
	LD C,21 
	SBC HL,BC 
	LD C,B 
	RET